#
# Conditional build
%bcond_without	esound		# build without esound plugin
%bcond_without	flac		# build without FLAC plugin
%bcond_without	jack		# build without jack plugin
%bcond_without	mikmod		# build without mikmod plugin
%bcond_without	nas		# build without nas plugin
#
Summary:	Alsaplayer - CD/FLAC/MOD/MP3/Ogg/WAV player
Summary(pl):	Alsaplayer - odtwarzacz CD/FLAC/MOD/MP3/Ogg/WAV
Name:		alsaplayer
Version:	0.99.76
Release:	4
License:	GPL
Group:		Applications/Sound
Source0:	ftp://ftp.alsa-project.org/pub/people/andy/%{name}-%{version}.tar.bz2
# Source0-md5:	a5566c15dbae1f5c86a08482eb405725
Source1:	%{name}.desktop
Source2:	%{name}.png
Patch0:		%{name}-docs.patch
Patch1:		%{name}-gcc33.patch
URL:		http://www.alsaplayer.org/
BuildRequires:	OpenGL-devel
BuildRequires:	alsa-lib-devel
BuildRequires:	audiofile-devel
BuildRequires:	autoconf
BuildRequires:	automake
%{?with_esound:BuildRequires:	esound-devel}
%{?with_flac:BuildRequires:	flac-devel}
BuildRequires:	gtk+-devel
%{?with_jack:BuildRequires:	jack-audio-connection-kit-devel >= 0.69.1}
%{?with_flac:BuildRequires:	libid3tag-devel}
BuildRequires:	libmad-devel
%{?with_mikmod:BuildRequires:	libmikmod-devel}
BuildRequires:	libsndfile-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtool
BuildRequires:	libvorbis-devel
%{?with_nas:BuildRequires:	nas-devel}
BuildRequires:	xosd-devel
Requires(post):	/sbin/ldconfig
Requires:	alsaplayer_output
Requires:	alsaplayer_ui
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1 libGLU.so.1
%define		_pkglibdir	%{_libdir}/%{name}

%description
AlsaPlayer is a new type of PCM player. It is heavily multi-threaded
and tries to exercise the ALSA library and driver quite a bit.
Features include:

Input addons:
- MP2 and MP3 support
- Ogg Vorbis support (subpackage)
- WAV support, 8-, 16-bit, mono, stereo, any sample rate
- CDDA support, CD Digital Audio playback! and thus USB ready :)
- Also plays files mapped by audiofs (CDDA)
- MAD MPEG audio
- Module support (mikmod) (subpcakage)
- FLAC support

Output addons:
- ALSA. Best supported of course :) (subpackage)
- OSS. Kernel native sound drivers
- Sparc. UltraSparc sound drivers
- SGI. SGI audio library driver
- ESD. Enlightened sound daemon support (subpackage)
- NAS. Network Audio System (subpakcage)
- low latency JACK output
- null :-)

Visual scopes:
- Stereoscope
- Monoscope
- Levelmeter
- Spacescope
- FFTscope
- FFTscope II
- Spectrum GL

General features:
- Full speed (pitch) control, positive *and* negative! (First Linux
  player that does this!! MP3's and CD's do varispeed :)
- Queue (playlist) support
- Concurrent visual scopes (open as many as you want)
- Multi-threaded design for efficient/skip free playback (RT)
- GUI Interface based on GTK+
- NOGUI operation for shell script usage
- On-screen-display based on xosd
- Plug-in core architecture
- Low latency mode, as low as 5ms when scheduled RT
- Effects stream
- Software based volume/pan control
- Accurate scope/audio syncing using ALSA features

%description -l pl
AlsaPlayer to nowy rodzaj odtwarzacza PCM. Jest wielowtkowy i prbuje
solidnie przewiczy sterowniki i bibliotek ALSA. Jego cechy to:

Wejcie:
- obsuga MP2 i MP3
- obsuga Ogg Vorbis (w podpakiecie)
- obsuga WAV, 8 i 16-bitowych, mono, stereo o dowolnej czstotliwoci
- obsuga CD Digital Audio
- odtwarzanie plikw podmapowanych przez audiofs (CDDA)
- obsuga MAD - MPEG Audio
- obsuga moduw (mikmod) (w podpakiecie)
- obsug bezstratnej kompresji dwiku FLAC

Wyjcie:
- OSS - natywne sterowniki z jdra
- ALSA - oczywicie najlepiej obsugiwana :) (w podpakiecie)
- Sparc - sterowniki dwiku dla UltraSparca
- SGI - biblioteka sterownikw dwiku SGI
- ESD - obsuga Owieconego demona dwiku (w podpakiecie)
- NAS - Sieciowego Systemu Audio (w podpakiecie)
- JACK - zestaw pocze dwiku o maych opnieniach (w podpakiecie)
- null :-)

Wizualizacja:
- Stereoskop
- Monoskop
- Wskanik poziomu dwiku
- Wskaniki oparte o analiz FFT
- analizator spektrum sygnau w oparciu o OpenGL

Oglne cechy:
- Kontrola szybkoci (w obie strony)
- obsuga kolejki (playlisty)
- obsuga wielu wskanikw naraz
- wielowtkowo
- interfejs graficzny bazujcy na GTK+
- operacje bez GUI na potrzeby skryptw
- tryb Informacje-na-ekranie oparty o xosd
- architektura wtyczek
- tryb "czasu rzeczywistego" dajcy opnienia rzdu 5ms
- programowa kontrola gonoci i balansu
- synchronizacja dwiku i wskanikw przy uyciu moliwoci ALSA

%package daemon
Summary:	Deamon interface for Alsaplayer
Summary(pl):	Interfejs demona alsaplayera
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description daemon
Deamon interface for Alsaplayer.

%description daemon -l pl
Interfejs demona alsaplayera.

%package input-audiofile
Summary:	Alsaplayer plugin for playing WAVE audio formats using audiofile
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw audio typu WAVE przy uyciu audiofile
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-audiofile
Alsaplayer plugin for playing WAVE audio formats (like AIFF, AIFC,
WAVE, ...) using audiofile library.

%description input-audiofile -l pl
Wtyczka alsaplayera do odtwarzania plikw audio typu WAVE (AIFF,
AIFC, WAVE, ...) przy uyciu biblioteki audiofile.

%package input-flac
Summary:	Alsaplayer plugin for playing FLAC files
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw FLAC
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-flac
Alsaplayer plugin for playing FLAC files.

%description input-flac -l pl
Wtyczka alsaplayera do odtwarzania plikw FLAC.

%package input-mad
Summary:	Alsaplayer plugin for playing MP3 files using MAD
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw MP3 przy pomocy MAD
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-mad
Alsaplayer plugin for playing MP3 files using MAD.

%description input-mad -l pl
Wtyczka alsaplayera do odtwarzania plikw MP3 przy pomocy MAD.

%package input-mikmod
Summary:	Alsaplayer plugin for playing mod files
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw mod
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-mikmod
Alsaplayer plugin for playing mod files.

%description input-mikmod -l pl
Wtyczka alsaplayera do odtwarzania plikw mod.

%package input-sndfile
Summary:	Alsaplayer plugin for playing WAVE audio formats using libsndfile
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw audio typu WAVE przy uyciu libsndfile
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-sndfile
Alsaplayer plugin for playing WAVE audio formats (like AIFF, AIFC,
WAVE, ...) using libsndfile library.

%description input-sndfile -l pl
Wtyczka do alsaplayera do odtwarzania plikw audio typu WAVE (AIFF,
AIFC, WAVE, ...) przy uyciu biblioteki libsndfile.

%package input-vorbis
Summary:	Alsaplayer plugin for playing Ogg/Vorbis files
Summary(pl):	Wtyczka alsaplayera do odtwarzania plikw Ogg/Vorbis
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description input-vorbis
Alsaplayer plugin for playing Ogg/Vorbis files.

%description input-vorbis -l pl
Wtyczka alsaplayera do odtwarzania plikw Ogg/Vorbis.

%package interface-gtk
Summary:	GTK+ interface for Alsaplayer
Summary(pl):	Interfejs GTK+ alsaplayera
Group:		X11/Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_ui

%description interface-gtk
GTK+ interface for Alsaplayer.

%description interface-gtk -l pl
Interfejs GTK+ alsaplayera.

%package interface-text
Summary:	Text interface for Alsaplayer
Summary(pl):	Interfejs tekstowy alsaplayera
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_ui

%description interface-text
Text interface for Alsaplayer.

%description interface-text -l pl
Interfejs tekstowy alsaplayera.

%package interface-xosd
Summary:	xosd interface for Alsaplayer
Summary(pl):	Interfejs xosd alsaplayera
Group:		X11/Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_ui

%description interface-xosd
xosd interface for Alsaplayer.

%description interface-xosd -l pl
Interfejs xosd alsaplayera.

%package output-alsa
Summary:	Alsaplayer plugin for playing through alsa drivers
Summary(pl):	Wtyczka alsaplayera do odtwarzania przez sterowniki alsa
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_output

%description output-alsa
Alsaplayer plugin for playing sound through alsa drivers.

%description output-alsa -l pl
Wtyczka alsaplayera do odtwarzania dwiku przez sterowniki alsa.

%package output-esound
Summary:	Alsaplayer plugin for playing through esound daemon
Summary(pl):	Wtyczka alsaplayera do odtwarzania przez demona esound
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_output

%description output-esound
Alsaplayer plugin for playing sound through esound daemon.

%description output-esound -l pl
Wtyczka alsaplayera do odtwarzania dwiku przez demona esound.

%package output-nas
Summary:	Alsaplayer plugin for playing through NAS daemon
Summary(pl):	Wtyczka do alsaplayera do odtwarzania przez demona NAS
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_output

%description output-nas
Alsaplayer plugin for playing sound through NAS (network audio system)
daemon.

%description output-nas -l pl
Wtyczka alsaplayera do odtwarzania dwiku przez demona NAS (network
audio system).

%package output-jack
Summary:	Alsaplayer plugin for playing sound through JACK
Summary(pl):	Wtyczka alsaplayera do odtwarzania dwiku przez JACK-a
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}
Provides:	alsaplayer_output

%description output-jack
Alsaplayer plugin for sound through JACK system.

%description output-jack -l pl
Wtyczka alsaplayera do odtwarzania dwiku przez system JACK.

%package scopes-gtk
Summary:	Alsaplayer plugins for visualization
Summary(pl):	Wtyczki alsaplayera do wizualizacji
Group:		X11/Applications/Multimedia
Requires:	%{name} = %{version}-%{release}

%description scopes-gtk
Alsaplayer plugins for visualization.

%description scopes-gtk -l pl
Wtyczki do alsaplayera do wizualizacji.

%package scopes-opengl
Summary:	Alsaplayer plugin for visualization using OpenGL
Summary(pl):	Wtyczka alsaplayera do wizualizacji z uyciem OpenGL
Group:		X11/Applications/Multimedia
Requires:	%{name} = %{version}-%{release}
Requires:	OpenGL

%description scopes-opengl
Alsaplayer plugin for visualization using OpenGL.

%description scopes-opengl -l pl
Wtyczka do alsaplayera do wizualizacji z uyciem OpenGL.

%package devel
Summary:	Alsaplayer header files
Summary(pl):	Pliki nagwkowe Alsaplayera
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for Alsaplayer library.

%description devel -l pl
Pliki nagwkowe biblioteki Alsaplayera.

%package static
Summary:	Alsaplayer static library
Summary(pl):	Biblioteka statyczna Alsaplayera
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Alsaplayer static library.

%description static -l pl
Biblioteka statyczna Alsaplayera.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
rm -f missing
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
CPPFLAGS=" -I/usr/X11R6/include"
LDFLAGS="%{rpmldflags} -L/usr/X11R6/lib"
export CPPFLAGS LDFLAGS
%configure \
	%{?with_esound:--en}%{!?with_esound:--dis}able-esd \
	%{?with_flac:--en}%{!?with_flac:--dis}able-flac \
	%{?with_jack:--en}%{!?with_jack:--dis}able-jack \
	%{?with_mikmod:--en}%{!?with_mikmod:--dis}able-mikmod \
	%{?with_nas:--en}%{!?with_nas:--dis}able-nas \
	%{?with_esound:--en}%{!?with_esound:--dis}able-esd \
	--enable-alsa \
	--enable-audiofile \
	--enable-gtk \
	--enable-oggflac \
	--enable-oggvorbis \
	--enable-opengl \
	--enable-oss \
	--enable-static

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	pkgconfigdir=%{_pkgconfigdir}

install %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}
install %{SOURCE2} $RPM_BUILD_ROOT%{_pixmapsdir}

rm -f $RPM_BUILD_ROOT%{_pkglibdir}/input/*.{a,la}
rm -f $RPM_BUILD_ROOT%{_pkglibdir}/interface/*.{a,la}
rm -f $RPM_BUILD_ROOT%{_pkglibdir}/output/*.{a,la}
rm -f $RPM_BUILD_ROOT%{_pkglibdir}/reader/*.{a,la}
rm -f $RPM_BUILD_ROOT%{_pkglibdir}/scopes/*.{a,la}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
echo
echo "Remember to install appropriate alsaplayer-input-* plugins"
echo "for files you want to play, for example:"
echo "alsaplayer-input-mad to play MP3s."
echo

%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS README ChangeLog
%attr(755,root,root) %{_bindir}/alsaplayer
%attr(755,root,root) %{_libdir}/libalsaplayer.so.0.0.2
%dir %{_pkglibdir}
%dir %{_pkglibdir}/input
%dir %{_pkglibdir}/interface
%dir %{_pkglibdir}/output
%dir %{_pkglibdir}/reader
%dir %{_pkglibdir}/scopes
%attr(755,root,root) %{_pkglibdir}/input/libcdda.so
%attr(755,root,root) %{_pkglibdir}/input/libwav.so
%attr(755,root,root) %{_pkglibdir}/output/liboss_out.so
%attr(755,root,root) %{_pkglibdir}/output/libnull_out.so
%attr(755,root,root) %{_pkglibdir}/reader/libfile.so
%attr(755,root,root) %{_pkglibdir}/reader/libhttp.so
%{_mandir}/man*/*
%{_desktopdir}/%{name}.desktop
%{_pixmapsdir}/%{name}.png

%files daemon
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/interface/libdaemon_interface.so

%files interface-gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/interface/libgtk_interface.so

%files interface-text
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/interface/libtext_interface.so

%files interface-xosd
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/interface/libxosd_interface.so

%files input-audiofile
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libaf.so

%if %{with flac}
%files input-flac
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libflac_in.so
%endif

%files input-mad
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libmad_in.so

%if %{with mikmod}
%files input-mikmod
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libmod.so
%endif

%files input-sndfile
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libsndfile_in.so

%files input-vorbis
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/input/libvorbis_in.so

%files output-alsa
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/output/libalsa_out.so

%if %{with esound}
%files output-esound
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/output/libesound_out.so
%endif

%if %{with jack}
%files output-jack
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/output/libjack_out.so
%endif

%if %{with nas}
%files output-nas
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/output/libnas_out.so
%endif

%files scopes-gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/scopes/libblurscope.so
%attr(755,root,root) %{_pkglibdir}/scopes/liblevelmeter.so
%attr(755,root,root) %{_pkglibdir}/scopes/liblogbarfft.so
%attr(755,root,root) %{_pkglibdir}/scopes/libmonoscope.so
%attr(755,root,root) %{_pkglibdir}/scopes/libspacescope.so
%attr(755,root,root) %{_pkglibdir}/scopes/libsynaescope.so

%files scopes-opengl
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/scopes/liboglspectrum.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libalsaplayer.so
%{_libdir}/libalsaplayer.la
%{_includedir}/alsaplayer
%{_pkgconfigdir}/alsaplayer.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libalsaplayer.a
